/* AVICallback.cpp : Implementierungsdatei
 * Copyright (C) 2000 Jrgen Eder
 *
 * $Header: /daten/sourcen/cvs/avimonitor/avicallback.cpp,v 1.1 2000/05/20 14:18:33 je Exp $
 * $Revision: 1.1 $
 * $Date: 2000/05/20 14:18:33 $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AVICallback.h"
#include "AVIMonitor.h"
#include "AVIMonitorDlg.h"
#include "DlgProxy.h"
#include "timerdialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL MySetEvent(HANDLE event)
{
	dwSEvents++;
	return SetEvent(event);
}


LRESULT PASCAL ControlCallbackProc(HWND /*hWnd*/, int /*nID*/) 
{ 
	return !errorStop;
}


LRESULT PASCAL StatusCallbackProc(HWND hWnd, int nID, LPSTR lpStatusText) 
{ 
    if (!captureDialog)         
		return FALSE;  

	captureDialog->SetWindowText(lpStatusText); 
#ifdef _DEBUG
	if (nID != 510) 
	{
		TRACE("default [%d / %ld]- %s\n",nID,GetTickCount(),lpStatusText);
	}
#endif

	return (LRESULT) TRUE; 
} 

LRESULT PASCAL ErrorCallbackProc(HWND hWnd, int nErrID, LPSTR lpErrorText) 
{ 
	if (!captureDialog)         
		return FALSE;  

    if (nErrID == 0)            // Starting a new major function. 
        return TRUE;            // Clear out old errors.  

	// Show the error identifier and text. 
	char gachBuffer[500];
    wsprintf(gachBuffer, "Error: %d\n\n%s", nErrID,lpErrorText);  
    captureDialog->MessageBox(gachBuffer, "Error", MB_OK | MB_ICONEXCLAMATION);   
	errorStop = TRUE;
	return (LRESULT) TRUE; 
} 

BOOL CheckPuffer(DWORD len)
{
	BOOL ret = TRUE;

	if ((nPos2Write+(long)sizeof(AVIDATEN)+(long)len) >= nMaxAVIRawData)
	{
		TRACE("Ringpuffer durchgelaufen, beginne bei 0\n");

		
		// Schreibe Kennung: "Puffer Neustart"
		// (Geht immer, da der Platz dafr reserviert wird)
		AVIDATEN *ptr = (AVIDATEN *)&AVIRawData[nPos2Write];
		ptr->nLength = 0;
		ptr->nTyp    = 0x80;
		ptr->Flags   = 0;
		ptr->nTime   = 0;
		MySetEvent(hCapEvent);

		
		nPos2Write = 0;
		durchlauf = TRUE;
	}
	if (durchlauf)
	{
		if ((nPos2Write+(long)sizeof(AVIDATEN)+(long)len) > nPos2Read)
		{
			// Ringpuffer ist bergelaufen
			TRACE("-1- Ringpuffer berlauf %ld %ld\n",nPos2Write,nPos2Read);
			errorStop = TRUE;
			ret = FALSE;
		}
	}
	else
	{
		if ((nPos2Write+(long)sizeof(AVIDATEN)+(long)len) < nPos2Read)
		{
			// Ringpuffer ist bergelaufen
			TRACE("-2- Ringpuffer berlauf %ld %ld\n",nPos2Write,nPos2Read);
			errorStop = TRUE;
			ret = FALSE;
		}
	}
	return ret;
}

BOOL SchreibeVideoInPuffer(LPVIDEOHDR lpVHdr)
{
	DWORD   len;
	BOOL    ret=TRUE;

	len = lpVHdr->dwBytesUsed;
    
	// Kontrolliere ob Daten noch in Ringpuffer passen
	ret = CheckPuffer(len);

    // Schreibe Daten in Ringpuffer
	if (!errorStop)
	{
		AVIDATEN *ptr	= (AVIDATEN *)&AVIRawData[nPos2Write];
		ptr->nLength	= len;
		ptr->nTyp		= 0;
		
		ptr->Flags		= (lpVHdr->dwFlags & VHDR_KEYFRAME)?AVIIF_KEYFRAME:0;
		ptr->nTime		= lpVHdr->dwTimeCaptured;
		memcpy(&AVIRawData[nPos2Write+sizeof(AVIDATEN)],lpVHdr->lpData,len);
//		TRACE("Speicher:%d %d %d %ld %ld->",ptr->nLength, ptr->nTyp, ptr->Flags,nPos2Read,nPos2Write);
		nPos2Write += (sizeof(AVIDATEN)+len+8)& ~3;
//		TRACE("%ld\n",nPos2Write);
		MySetEvent(hCapEvent);
	}
	return ret;
}

BOOL SchreibeAudioInPuffer(LPWAVEHDR lpWHdr)
{
	DWORD   len;
	BOOL    ret=TRUE;

	len = lpWHdr->dwBytesRecorded;

	// Kontrolliere ob Daten noch in Ringpuffer passen
	ret = CheckPuffer(len);

  	// Schreibe Daten in Ringpuffer
	if (!errorStop)
	{
		AVIDATEN *ptr	= (AVIDATEN *)&AVIRawData[nPos2Write];
		ptr->nLength	= len;
		ptr->nTyp		= 1;
		
		ptr->Flags		= AVIIF_KEYFRAME;
		ptr->nTime		= 0;//lpVHdr->dwTimeCaptured;
		ptr->nBlockAlign= ba_info->nBlockAlign;
		memcpy(&AVIRawData[nPos2Write+sizeof(AVIDATEN)],lpWHdr->lpData,len);
//		TRACE("Speicher:%d %d %d %ld %ld->",ptr->nLength, ptr->nTyp, ptr->Flags,nPos2Read,nPos2Write);
		nPos2Write += (sizeof(AVIDATEN)+len+8)& ~3;
//		TRACE("%ld\n",nPos2Write);
		MySetEvent(hCapEvent);
	}
	return ret;
}

LRESULT CALLBACK capVideoStreamCallback(HWND hWnd, LPVIDEOHDR lpVHdr)
{
	if (!bi_info) 
	{
		errorStop = TRUE;
		return FALSE;
	}

    if (hCapEvent) SchreibeVideoInPuffer(lpVHdr);

	if (timerRuns)
	{
		//TRACE("timer %d\n",timer);
		CTime t = CTime::GetCurrentTime();

		if ((t.GetHour()   == stopzeit.stunde) &&
			(t.GetMinute() == stopzeit.minute) &&
			(t.GetSecond() == stopzeit.sekunde))
		{
			timer = FALSE;
		}
	}

	char geschrieben_txt[200];
	wsprintf(geschrieben_txt,"Datei: %s - %ld kBytes (%ld Frames) - Dropped: %ld",aktuelle_file,fileByteCounter/1024,videoStreamCounter,videoDropOuts);
	captureDialog->SetWindowText(geschrieben_txt);     
	return TRUE;
}

LRESULT CALLBACK capWaveStreamCallback(HWND hWnd,LPWAVEHDR lpWHdr)
{
	if (!ba_info) 
	{
		errorStop = TRUE;
		return FALSE;
	}

	TRACE("Audiolnge %d 0x%x\n",lpWHdr->dwBytesRecorded,lpWHdr->lpNext);
    if (hCapEvent) SchreibeAudioInPuffer(lpWHdr);
	
	if (timerRuns && !timer)
	{
		errorStop = TRUE;
	}

	return TRUE;
}

#ifdef nie
LRESULT CALLBACK capVideoStreamCallback(HWND hWnd, LPVIDEOHDR lpVHdr)
{
	HRESULT hr;
	DWORD   len;
	long   dwWritten;
	PAVISTREAM ps;
	int    drops=0;

	if (aufnahmeStart)	// Aufnahme wurde gestartet -> merke mir ersten Zeitstempel
	{
		videoTime = lpVHdr->dwTimeCaptured;
		aufnahmeStart = FALSE;
		videoDropOuts = 0;
	}
	else				// Aufnahme luft bereits, untersuche jetzt, ob Frames ausgelassen wurden
	{					// (= drop outs)
		if (videoTimePerFrame > 0)  // Sicherheitsabfrage
		{
			drops = ((lpVHdr->dwTimeCaptured-videoTime)/videoTimePerFrame)-1;
//TRACE("Test1: %ld %ld %ld \n",lpVHdr->dwTimeCaptured,videoTime,videoTimePerFrame);
			if (drops > 1)
			{
				videoDropOuts+=drops;
			}
/*
			if (drops > 20)
			{
				errorStop = TRUE;	// Abbrechen
			}
*/
			if (drops < 0)			// drfte eigentlich nicht vorkommen ?!
			{
				drops = 0;
			}
			videoTime = lpVHdr->dwTimeCaptured;
		}
	}

	if (!bi_info) 
	{
		errorStop = TRUE;
		return FALSE;
	}

	ps = (komprimierung)?psVideoCompressed[fileUseNum]:psVideo[fileUseNum];
	if (!ps) return TRUE;

	len = lpVHdr->dwBytesUsed;

	

/*
    TRACE("Header: %d %d %d %d %d %d\n",
		lpVHdr->dwBufferLength,
		lpVHdr->dwBytesUsed,
		lpVHdr->dwFlags,
		lpVHdr->dwReserved,
		lpVHdr->dwTimeCaptured,
		lpVHdr->dwUser);
	TRACE("Videolnge %d\n",len);
*/

	// Falls Drop-Outs auftraten, wird das zuletzt empfangene Frame n-mal gespeichert
	// -> dadurch bleibt (hoffentlich) Bild und Ton synchron
	while(drops >= 0)
	{
		hr = AVIStreamWrite(ps,// stream pointer
			videoStreamCounter++,			// time of this frame
			1,								// number to write
			(LPBYTE) lpVHdr->lpData,
			len,							// size of this frame
			(lpVHdr->dwFlags & VHDR_KEYFRAME)?AVIIF_KEYFRAME:0,			 // flags....
			NULL,
			&dwWritten);
		if (hr != AVIERR_OK)
		{
			errorStop = TRUE;
			TRACE("Fehler in StreamWrite (Video)%ld\n",hr);
			return FALSE;
		}
		
		TRACE("Geschrieben: %ld\n",dwWritten);
		fileByteCounter+=dwWritten;
		char geschrieben_txt[200];
		wsprintf(geschrieben_txt,"Datei: %s_%03d.avi - %ld kBytes (%ld Frames) - Dropped: %ld",filename,fileUseNum+file_start_nummer,fileByteCounter/1024,videoStreamCounter,videoDropOuts);
		captureDialog->SetWindowText(geschrieben_txt);     
		drops--;
	}

	if (timerRuns)
	{
		//TRACE("timer %d\n",timer);
		CTime t = CTime::GetCurrentTime();

		if ((t.GetHour()   == stopzeit.stunde) &&
			(t.GetMinute() == stopzeit.minute) &&
			(t.GetSecond() == stopzeit.sekunde))
		{
			timer = FALSE;
		}
	}
	return TRUE;
}

LRESULT CALLBACK capWaveStreamCallback(HWND hWnd,LPWAVEHDR lpWHdr)
{
	HRESULT hr;
	DWORD len,t;

	if (!ba_info) 
	{
		errorStop = TRUE;
		return FALSE;
	}
	if (!ba_info->nBlockAlign)
	{
		ba_info->nBlockAlign = 1;
	}


	if (!psAudio[fileUseNum]) return TRUE;	// Ton wird nicht aufgenommen

	len = lpWHdr->dwBytesRecorded;
	
	TRACE("Audiolnge %d 0x%x\n",len,lpWHdr->lpNext);
	fileByteCounter+=len;

	
	char geschrieben_txt[200];
	wsprintf(geschrieben_txt,"Datei: %s_%03d.avi - %ld kBytes (%ld Frames) - Dropped: %ld",filename,fileUseNum+file_start_nummer,fileByteCounter/1024,videoStreamCounter,videoDropOuts);
	//wsprintf(geschrieben_txt,"Datei: %s_%03d.avi - %ld kBytes (%ld Frames)",filename,fileUseNum+file_start_nummer,fileByteCounter/1024,videoStreamCounter);
	captureDialog->SetWindowText(geschrieben_txt);     

	
	
	hr = AVIStreamWrite(psAudio[fileUseNum],	// stream pointer
			audioStreamCounter,					// time of this frame
			len/ba_info->nBlockAlign,								// number to write
			(LPBYTE) lpWHdr->lpData,
			len,								// size of this frame
			AVIIF_KEYFRAME,						// flags....
			NULL,
			NULL);
	audioStreamCounter += len/ba_info->nBlockAlign;
//	TRACE("Audio: %ld\n",audioStreamCounter);

	if (fileByteCounter >= fileMax)
	{
		fileUseNum++;
		if ((fileUseNum >= MAX_CAP_FILES) || !pfile[fileUseNum])
		{
			fileUseNum--; // vorsichtshalber
			errorStop = TRUE; // Aufnahme stoppen
		}
		else
		{
			t = fileUseNum-1;
			
			TRACE("Zeit : %ld -",GetTickCount());
			if (psVideo[t])
			{
				AVIStreamRelease(psVideo[t]);
			}
			
			if (psAudio[t])
			{
				AVIStreamRelease(psAudio[t]);
			}
			
			//if (pfile[t])
			//	AVIFileClose(pfile[t]);
			//pfile[t]   = 0;

			psAudio[t] = 0;
			psVideo[t] = 0;

		    fileByteCounter=0;
			TRACE("%ld -\n",GetTickCount());
		}
	}
	if (hr != AVIERR_OK)
	{
		errorStop = TRUE;
		TRACE("Fehler in StreamWrite (Audio)%ld\n",hr);
		return FALSE;
	}

	if (timerRuns && !timer)
	{
		errorStop = TRUE;
	}

	return TRUE;
}
#endif 


