/* AVIMonitorDlg.cpp : Implementierungsdatei
 * Copyright (C) 2000 Jrgen Eder
 *
 * $Header: /daten/sourcen/cvs/avimonitor/avimonitordlg.cpp,v 1.6 2000/05/20 14:18:41 je Exp $
 * $Revision: 1.6 $
 * $Date: 2000/05/20 14:18:41 $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AVIMonitor.h"
#include "AVIMonitorDlg.h"
#include "DlgProxy.h"
#include "timerdialog.h"
#include "AVICallback.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAVIMonitorDlg Dialogfeld

IMPLEMENT_DYNAMIC(CAVIMonitorDlg, CDialog);

CAVIMonitorDlg::CAVIMonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAVIMonitorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAVIMonitorDlg)
	m_max = 2000;
	m_p1 = _T("D");
	m_p2 = _T("");
	m_p3 = _T("");
	m_p4 = _T("");
	m_Rate = 25.0;
	m_l1 = 1;
	m_l2 = 1;
	m_l3 = 1;
	m_l4 = 1;
	m_Dateiname = _T("cap_,0");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
	m_Aufnahme = 0;
	m_DriverNum = -1;
	memset(&compressopts, 0, sizeof(compressopts));

	captureDialog = this;
	AVIFileInit();


	DWORD threadId;
	hCapEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	hThread   = CreateThread( NULL, 0, Speichern, this, 0 , &threadId );
}

CAVIMonitorDlg::~CAVIMonitorDlg()
{
	// Existiert fr dieses Dialogfeld ein Automatisierungs-Proxy, setzen Sie
	//  seinen Gegenzeiger auf dieses Dialogfeld auf NULL, um anzuzeigen,
	//  dass das Dialogfeld gelscht wurde.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;

	AVIFileExit();

	if (hThread)   
	{
		bThreadStoppen = TRUE;
		MySetEvent(hCapEvent);
		WaitForSingleObject(hThread,INFINITE);
		CloseHandle(hThread);
	}
	if (hCapEvent) CloseHandle(hCapEvent);
	DelInfoLen();
}

void CAVIMonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAVIMonitorDlg)
	DDX_Control(pDX, IDC_BUTTON1, m_Button);
	DDX_Text(pDX, IDC_EDIT5, m_max);
	DDX_Text(pDX, IDC_PLATTE1, m_p1);
	DDX_Text(pDX, IDC_PLATTE2, m_p2);
	DDX_Text(pDX, IDC_PLATTE3, m_p3);
	DDX_Text(pDX, IDC_PLATTE4, m_p4);
	DDX_Text(pDX, IDC_RATE, m_Rate);
	DDX_Text(pDX, IDC_PLATTE5, m_l1);
	DDX_Text(pDX, IDC_PLATTE6, m_l2);
	DDX_Text(pDX, IDC_PLATTE7, m_l3);
	DDX_Text(pDX, IDC_PLATTE8, m_l4);
	DDX_Text(pDX, IDC_DATEINAME, m_Dateiname);
	DDV_MaxChars(pDX, m_Dateiname, 200);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAVIMonitorDlg, CDialog)
	//{{AFX_MSG_MAP(CAVIMonitorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_COMMAND(ID_KONFIGURATION_SOURCE, OnKonfigurationSource)
	ON_COMMAND(ID_KONFIGURATION_KOMPRESSION, OnKonfigurationKompression)
	ON_COMMAND(ID_KONFIGURATION_FORMAT, OnKonfigurationFormat)
	ON_COMMAND(ID_KONFIGURATION_DISPLAY, OnKonfigurationDisplay)
	ON_COMMAND(ID_KONFIGURATION_AUDIO, OnKonfigurationAudio)
	ON_COMMAND(ID_DATEI_ENDE, OnDateiEnde)
	ON_COMMAND(ID_CAPTURING_START, OnCapturingStart)
	ON_COMMAND(IDM_OVERLAY, OnOverlay)
	ON_COMMAND(IDM_PREVIEW, OnPreview)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE1, OnVideotreiberDevice1)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE10, OnVideotreiberDevice10)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE2, OnVideotreiberDevice2)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE3, OnVideotreiberDevice3)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE4, OnVideotreiberDevice4)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE5, OnVideotreiberDevice5)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE6, OnVideotreiberDevice6)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE7, OnVideotreiberDevice7)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE8, OnVideotreiberDevice8)
	ON_COMMAND(ID_VIDEOTREIBER_DEVICE9, OnVideotreiberDevice9)
	ON_COMMAND(ID_KONFIGURATION_TIMER, OnKonfigurationTimer)
	ON_WM_TIMER()
	ON_COMMAND(ID_CAPTURING_TIMERGESTEUERT, OnCapturingTimergesteuert)
	ON_COMMAND(ID_KONFIGURATION_KOMPRESSIONVIDEO, OnKonfigurationKompressionvideo)
	ON_COMMAND(ID_HILFE_INFO, OnHilfeInfo)
	ON_COMMAND(ID_HILFE_INDEX, OnHilfeIndex)
	ON_COMMAND(ID_DATEI_LADEN, OnDateiLaden)
	ON_COMMAND(ID_DATEI_SPEICHERNUNTER, OnDateiSpeichernunter)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_COMMAND(ID_AUFNAHME_COMPUTERRUNTERFAHRENNACHAUFNAHME, OnAufnahmeComputerrunterfahrennachaufnahme)
	ON_COMMAND(ID_OVERLAY_STATIC, OnOverlayStatic)
	ON_WM_MOVE()
	ON_COMMAND(IDM_SPEZIAL_DC10, OnSpezialDc10)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAVIMonitorDlg Nachrichten-Handler

BOOL CAVIMonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	int error=0;

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	main_menu = ::GetMenu(m_hWnd);

	memset(&startzeit,0,sizeof(startzeit));
	memset(&stopzeit,0,sizeof(stopzeit));
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	timer1 = SetTimer(1,800,NULL);
	if (timer1)
	{
		timerOk = TRUE;
	}
	else
	{
		MessageBox("Timer konnte nicht initialisiert werden","Fehler",MB_OK|MB_ICONEXCLAMATION);
		::EnableMenuItem(main_menu,ID_CAPTURING_TIMERGESTEUERT,MF_GRAYED+MF_BYCOMMAND);
		::EnableMenuItem(main_menu,ID_KONFIGURATION_TIMER,MF_GRAYED+MF_BYCOMMAND);
	}

	
	m_hCaptureWnd  = capCreateCaptureWindow ("Test Capture",WS_CHILD | WS_VISIBLE , CAP_WIN_POS_X, CAP_WIN_POS_Y, 160, 120, m_hWnd, 100);
	
	if (!m_hCaptureWnd)
	{
		MessageBox("Cannot open capturing window","Error",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	// Lese den Dateinamen der Default-Konfiguration
	char pfad[1000];
	GetProfileString("AVIMonitor","ConfigFile","",pfad,sizeof(pfad));
    OnChangeVideoDevice(GetProfileInt("AVIMonitor","Device",0));

	capDriverGetCaps(m_hCaptureWnd,&CaptureCaps,sizeof(CaptureCaps));
	if (!CaptureCaps.fHasOverlay)
	{
		OutModus = 1;
	    // Overlay wird vom Treiber nicht untersttzt -> Menpunkt nicht anwhlbar machen
		::EnableMenuItem(main_menu,IDM_OVERLAY,MF_GRAYED+MF_BYCOMMAND);
	}

	if (pfad[0])
	{
		DateiLaden(pfad);
	}
	else
	{
		if (!OutModus)
			OnOverlay();
		else
			OnPreview();
	}

	if (!CaptureCaps.fHasDlgVideoSource)EnableMenuItem(main_menu,ID_KONFIGURATION_SOURCE,MF_GRAYED+MF_BYCOMMAND);
	if (!CaptureCaps.fHasDlgVideoFormat)EnableMenuItem(main_menu,ID_KONFIGURATION_FORMAT,MF_GRAYED+MF_BYCOMMAND);
	if (!CaptureCaps.fHasDlgVideoDisplay)EnableMenuItem(main_menu,ID_KONFIGURATION_DISPLAY,MF_GRAYED+MF_BYCOMMAND);


	CheckWindowDim();



/*	
	if (!capSetCallbackOnFrame(m_hCaptureWnd, FrameCallbackProc))
	{
		TRACE("Fehler in capSetCallbackOnFrame\n");
		error += 1;
	}
*/
	if (!capSetCallbackOnStatus(m_hCaptureWnd, StatusCallbackProc))
	{
		TRACE("Fehler in capSetCallbackOnStatus\n");
		error += 2;
	}
	if (!capSetCallbackOnError(m_hCaptureWnd, ErrorCallbackProc))
	{
		TRACE("Fehler in capSetCallbackOnError\n");
		error += 4;
	}
	if (!capSetCallbackOnCapControl(m_hCaptureWnd, ControlCallbackProc))
	{
		TRACE("Fehler in capControlCallback\n");
		error += 8;
	}
	if (!capSetCallbackOnVideoStream(m_hCaptureWnd, capVideoStreamCallback))
	{
		TRACE("Fehler in capSetCallbackOnVideoStream\n");
		error += 0x10;
	}
	if (!capSetCallbackOnWaveStream(m_hCaptureWnd, capWaveStreamCallback))
	{
		TRACE("Fehler in capSetCallbackOnWaveStream\n");
		error += 0x20;
	}
/*
	if (!capSetCallbackOnYield(m_hCaptureWnd, capYieldCallback))
	{
		TRACE("Fehler in capSetCallbackOnYield\n");
		error += 0x80;
	}
*/

	if (error)
	{
		char errbuff[1000];

		strcpy(errbuff,"Whrend der Initialisierung trat ein Fehler auf:\n\n");
		if (error & 0x01) strcpy(&errbuff[strlen(errbuff)],"Fehler in capSetCallbackOnFrame\n");
		if (error & 0x02) strcpy(&errbuff[strlen(errbuff)],"Fehler in capSetCallbackOnStatus\n");
		if (error & 0x04) strcpy(&errbuff[strlen(errbuff)],"Fehler in capSetCallbackOnError\n");
		if (error & 0x08) strcpy(&errbuff[strlen(errbuff)],"Fehler in capControlCallback\n");
		if (error & 0x10) strcpy(&errbuff[strlen(errbuff)],"Fehler in capSetCallbackOnVideoStream\n");
		if (error & 0x20) strcpy(&errbuff[strlen(errbuff)],"Fehler in capSetCallbackOnWaveStream\n");
		if (error & 0x40) strcpy(&errbuff[strlen(errbuff)],"Fehler in capDriverConnect\n");
		if (error & 0x80) strcpy(&errbuff[strlen(errbuff)],"Fehler in capSetCallbackOnYield\n");
		MessageBox(errbuff,"Fehler",MB_OK|MB_ICONEXCLAMATION);
	}



	CString tx;
	char szDeviceName[80];
	char szDeviceVersion[80];
	int wIndex;

	for (wIndex = 0; wIndex < 10; wIndex++) 
	{
		if (capGetDriverDescription (wIndex, szDeviceName, sizeof (szDeviceName), szDeviceVersion, sizeof (szDeviceVersion)))
		{
			// Append name to list of installed capture drivers
			// and then let the user select a driver to use.    
			tx  = szDeviceName;
			tx += ",";
			tx += szDeviceVersion;
			TRACE("Treiber %d =>  %s / %s\n",wIndex,szDeviceName,szDeviceVersion);
			::ModifyMenu(main_menu,ID_VIDEOTREIBER_DEVICE1+wIndex,MF_BYCOMMAND+MF_STRING,ID_VIDEOTREIBER_DEVICE1+wIndex,tx);
		}
		else
		{
			for( ; wIndex < 10; wIndex++)
			{
				::DeleteMenu(main_menu,ID_VIDEOTREIBER_DEVICE1+wIndex,MF_BYCOMMAND);
			}
			break;
		}
	} 
    ::CheckMenuItem(main_menu,ID_VIDEOTREIBER_DEVICE1+m_DriverNum,MF_BYCOMMAND+MF_CHECKED);
    ::CheckMenuItem(main_menu,ID_OVERLAY_STATIC,MF_BYCOMMAND+((overlayStatisch == TRUE)?MF_CHECKED:MF_UNCHECKED));

	// Timer-Auflsung auf 1 ms setzen
	timeBeginPeriod(1);


	// Bildschirmschoner ausschalten
	SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,FALSE,NULL,SPIF_SENDWININICHANGE);


	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CAVIMonitorDlg::CheckWindowDim(void)
{
	RECT rect;
	int h,w;
	CAPSTATUS CapStatus;

    ::CheckMenuItem(main_menu,ID_OVERLAY_STATIC,MF_BYCOMMAND+((overlayStatisch == TRUE)?MF_CHECKED:MF_UNCHECKED));

	if (overlayStatisch)
	{
		::SetWindowPos(m_hCaptureWnd, NULL, 0, 0, 240, 180, SWP_NOZORDER | SWP_NOMOVE); 
		capGetStatus(m_hCaptureWnd, &CapStatus, sizeof (CAPSTATUS));
	}
	else
	{
		
		if (capGetStatus(m_hCaptureWnd, &CapStatus, sizeof (CAPSTATUS)))
		{
			TRACE("WindowDim: %d %d\n",CapStatus.uiImageWidth,CapStatus.uiImageHeight);
			::SetWindowPos(m_hCaptureWnd, NULL, 0, 0, CapStatus.uiImageWidth, CapStatus.uiImageHeight, SWP_NOZORDER | SWP_NOMOVE); 
		}
		else
		{
			TRACE("Verwende Standard\n");
			::SetWindowPos(m_hCaptureWnd, NULL, 0, 0, 320, 240, SWP_NOZORDER | SWP_NOMOVE); 
		}
	}
	
	GetWindowRect(&rect);
	w = ((rect.right - rect.left - CAP_WIN_POS_X - 20) < (int)CapStatus.uiImageWidth)?CapStatus.uiImageWidth+CAP_WIN_POS_X+20:rect.right - rect.left;
    h = ((rect.bottom- rect.top  - CAP_WIN_POS_Y - 20) < (int)CapStatus.uiImageHeight)?CapStatus.uiImageHeight+CAP_WIN_POS_Y+20:rect.bottom- rect.top;
	SetWindowPos(NULL, 0, 0, w, h, SWP_NOZORDER | SWP_NOMOVE); 
}

void CAVIMonitorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CAVIMonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CAVIMonitorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automatisierungs-Server sollten nicht beendet werden, wenn der Benutzer
//  das UI schliet und ein Controller eines seiner Objekte nicht freigibt.
//  Diese Nachrichten-Handler stellen sicher, dass das UI ausgeblendet wird,
//  das Dialogfeld beim Schlieen aber erhalten bleibt, wenn der Proxy
//  noch in Gebrauch ist.

void CAVIMonitorDlg::OnClose() 
{
	if (CanExit())
	{
		TRACE("OnClose\n");
		capDriverDisconnect(m_hCaptureWnd);

		if (timerOk) KillTimer(timer1);
		timeEndPeriod(1);
		SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,TRUE,NULL,SPIF_SENDWININICHANGE);
	    ::WinHelp(m_hWnd,"avimonitor.hlp",HELP_QUIT,0);
		CDialog::OnClose();
	}
}

void CAVIMonitorDlg::OnOK() 
{
//	if (CanExit())
//		CDialog::OnOK();
}

void CAVIMonitorDlg::OnCancel() 
{
	if (!m_Aufnahme) 
	{
		TRACE("OnCancel\n");
		if (CanExit())
		{
			CDialog::OnCancel();
		}
	}
}

BOOL CAVIMonitorDlg::CanExit()
{
	// Existiert das Proxy-Objekt noch, so gibt der Automatisierungs
	//  Controller diese Anwendung weiterhin nicht frei. Lassen Sie
	//  das Dialogfeld weiter existieren, blenden Sie nur seine UI aus.
	if (m_pAutoProxy != NULL)
	{
		//ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

void CAVIMonitorDlg::OnKonfigurationSource() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	capDlgVideoSource(m_hCaptureWnd);
}

void CAVIMonitorDlg::OnKonfigurationKompression() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	char buffer[300];//="c:\\avimon.avi";
	HRESULT hr;
	PAVIFILE pf;
	PAVISTREAM pv;
	AVISTREAMINFO vs;
	AVICOMPRESSOPTIONS FAR * aopts[1] = {&compressopts};
	LPBITMAPINFO bi;
	int vl;
	
	
	/*	Komprimierung:

		Es wird nicht der Standarddialog des Capture-Fensters verwendet,
		da das abpspeichern ber die AVI...-Funktionen erfolgt.
		Die entsprechende AVI-Funktion kann aber nur aufgerufen werden, wenn
		bereits ein Stream geffnet ist. Deshalb wird jetzt (temporr) 
		eine AVI-Datei (+ Video-Stream) erzeugt. 

    */
	
	
	UpdateData();

	if (GetTempPath(sizeof(buffer),buffer) > 0)
	{
		strcpy(&buffer[strlen(buffer)],"\\avimon.avi");
	}
	else
	{
		strcpy(buffer,"avimon.avi");
	}
	TRACE("temporre Datei: %s\n",buffer);

	// Ermittle eingestellte Videoparameter (Breite/Hhe)
	vl = capGetVideoFormat(m_hCaptureWnd,NULL,0);
	if (vl > 0)
	{
		bi = (LPBITMAPINFO)malloc(vl);
	    if (!bi)
		{
				TRACE("Fehler: bi = NULL\n");
				return;
		}
	}
	else
	{
		TRACE("Fehler in capGetVideoFormat: Lnge = 0\n");
		return;
	}
	capGetVideoFormat(m_hCaptureWnd,bi,vl);



	// Setze die Stream-Struktur genauso, wie spter whrend der Aufnahme
	memset(&vs, 0, sizeof(vs));
	vs.fccType                = streamtypeVIDEO;// stream type
	if (DC10PlusTVOut)
	{
		vs.fccHandler             = mmioFOURCC('M','J','P','G');;
	}
	else
	{
		vs.fccHandler             = 0;
	}
	vs.dwScale                = CaptureParms.dwRequestMicroSecPerFrame;
	vs.dwRate                 = 1000000;
	vs.dwSuggestedBufferSize  = 0;
	vs.dwQuality			   = -1;
	SetRect(&vs.rcFrame, 0, 0,bi->bmiHeader.biWidth,bi->bmiHeader.biHeight);


	// Struktur wird nicht mehr bentigt
	free(bi);

	// ffne AVI-Datei und erzeuge danach einen Videostream
	hr = AVIFileOpen(&pf,buffer,OF_WRITE|OF_CREATE,NULL);
	if (hr != AVIERR_OK) return;
	hr = AVIFileCreateStream(pf,&pv,&vs);	    
	if (hr != AVIERR_OK) return;
		
	// Dialog anzeigen
	if (IDOK == AVISaveOptions(m_hWnd, 0, 1, &pv, (LPAVICOMPRESSOPTIONS *) &aopts))
	{
		// Setze Flag, dadurch werden beim Speichern dann noch zustzliche
		// Funktionen aufgerufen
		// -> Betrifft die Funktionen: Hintergundthread
		komprimierung = TRUE;
	}
	else
	{
		komprimierung = FALSE;
	}

	// AVI-Datei und Stream schlieen
	AVIStreamRelease(pv);
	AVIFileRelease(pf);
}

void CAVIMonitorDlg::OnKonfigurationKompressionvideo() 
{
	capDlgVideoCompression(m_hCaptureWnd);
}

void CAVIMonitorDlg::OnKonfigurationFormat() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	capDlgVideoFormat(m_hCaptureWnd);

	CheckWindowDim();
}

void CAVIMonitorDlg::OnKonfigurationDisplay() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	capDlgVideoDisplay(m_hCaptureWnd);
}

void CAVIMonitorDlg::OnKonfigurationAudio() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen

		ACMFORMATCHOOSE cfmt;
		DWORD dwSize;
	    LPWAVEFORMATEX      wfxSelection; 
		
		
		// Ask the ACM what the largest wave format is.....
		acmMetrics(NULL,
			ACM_METRIC_MAX_SIZE_FORMAT,
			&dwSize);
		
		// Get the current audio format
		dwSize = max (dwSize, capGetAudioFormatSize (m_hCaptureWnd));
		if (wfxSelection = (LPWAVEFORMATEX) malloc(dwSize)) 
		{
			capGetAudioFormat(m_hCaptureWnd, wfxSelection, (WORD)dwSize) ;
			
			memset (&cfmt, 0, sizeof (ACMFORMATCHOOSE));
			cfmt.cbStruct = sizeof (ACMFORMATCHOOSE);
			cfmt.fdwStyle =  ACMFORMATCHOOSE_STYLEF_INITTOWFXSTRUCT;
			cfmt.fdwEnum =   ACM_FORMATENUMF_HARDWARE | ACM_FORMATENUMF_INPUT;
			cfmt.hwndOwner = m_hWnd;
			cfmt.pwfx =     wfxSelection;
			cfmt.cbwfx =    dwSize;
			
			if (!acmFormatChoose(&cfmt)) 
			{
				if (!capSetAudioFormat(m_hCaptureWnd, wfxSelection, (WORD)wfxSelection->cbSize + sizeof (WAVEFORMATEX)))
				{
					TRACE("Fehler in capSetAudioFormat()\n");
				}
			}
			free(wfxSelection) ;
		}

}

void CAVIMonitorDlg::OnDateiEnde() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	if (CanExit())
	{
		TRACE("OnDateiEnde\n");
		CDialog::OnOK();
	}
}

void CAVIMonitorDlg::OnCapturingStart() 
{
	timerRuns = FALSE;
    ::CheckMenuItem(main_menu,ID_CAPTURING_TIMERGESTEUERT,MF_BYCOMMAND+((timerRuns == TRUE)?MF_CHECKED:MF_UNCHECKED));

	OnVideoCapturing();
}


void CAVIMonitorDlg::OnOverlay() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	TRACE("Men: OnOverlay\n");
	capPreview(m_hCaptureWnd,0);
	capPreviewRate(m_hCaptureWnd,(int)0);
	capPreviewScale(m_hCaptureWnd,0);
	capOverlay(m_hCaptureWnd,1);
	OutModus = 0;
	::CheckMenuItem(main_menu,IDM_OVERLAY,MF_BYCOMMAND+MF_CHECKED);
	::CheckMenuItem(main_menu,IDM_PREVIEW,MF_BYCOMMAND+MF_UNCHECKED);
}

void CAVIMonitorDlg::OnPreview() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	TRACE("Men: OnPreview\n");

	UpdateData();
	
	if (m_Rate <= 0) 
	{
		m_Rate = 15.;	// Default
		UpdateData(FALSE);
	}

	capPreview(m_hCaptureWnd,1);
	capPreviewRate(m_hCaptureWnd,(int)m_Rate);
	capPreviewScale(m_hCaptureWnd,0);
	OutModus = 1;
    ::CheckMenuItem(main_menu,IDM_OVERLAY,MF_BYCOMMAND+MF_UNCHECKED);
    ::CheckMenuItem(main_menu,IDM_PREVIEW,MF_BYCOMMAND+MF_CHECKED);
}


void CAVIMonitorDlg::OnChangeVideoDevice(int neu) 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	if (m_DriverNum == neu) return;  // keine nderung

	// Nach dem Programmstart ist die Standardeinstellung = -1 !!!
	// -> wird jetzt korrigiert auf 0
	if (m_DriverNum < 0) m_DriverNum = 0;

	capDriverDisconnect(m_hCaptureWnd);
    ::CheckMenuItem(main_menu,ID_VIDEOTREIBER_DEVICE1+m_DriverNum,MF_BYCOMMAND+MF_UNCHECKED);
	if (!capDriverConnect (m_hCaptureWnd, neu))
	{
		TRACE("Fehler in capDriverConnect\n");
		MessageBox("Treiber kann nicht angesprochen werden\nVerwende weiterhin alte Einstellung","Fehler",MB_OK|MB_ICONEXCLAMATION);
		capDriverConnect (m_hCaptureWnd, m_DriverNum);
	}
	else
	{
		m_DriverNum = neu;
	}
    ::CheckMenuItem(main_menu,ID_VIDEOTREIBER_DEVICE1+m_DriverNum,MF_BYCOMMAND+MF_CHECKED);

	char buffer[10];
	sprintf(buffer,"%d",m_DriverNum);
	WriteProfileString("AVIMonitor","Device",buffer);
	CheckWindowDim();
    CalcInfoLen();
}

void CAVIMonitorDlg::OnVideotreiberDevice1() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(0);	
}

void CAVIMonitorDlg::OnVideotreiberDevice10() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(9);	
}

void CAVIMonitorDlg::OnVideotreiberDevice2() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(1);	
}

void CAVIMonitorDlg::OnVideotreiberDevice3() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(2);	
	
}

void CAVIMonitorDlg::OnVideotreiberDevice4() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(3);	
}

void CAVIMonitorDlg::OnVideotreiberDevice5() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(4);	
}

void CAVIMonitorDlg::OnVideotreiberDevice6() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(5);	
}

void CAVIMonitorDlg::OnVideotreiberDevice7() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(6);	
}

void CAVIMonitorDlg::OnVideotreiberDevice8() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(7);	
}

void CAVIMonitorDlg::OnVideotreiberDevice9() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	OnChangeVideoDevice(8);	
}


void CAVIMonitorDlg::OnKonfigurationTimer() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	CTimerDialog dlg(this);

	char buffer[100];
	sprintf(buffer,"%02d:%02d:%02d",startzeit.stunde,startzeit.minute,startzeit.sekunde);
	dlg.m_Start = buffer;
	sprintf(buffer,"%02d:%02d:%02d",stopzeit.stunde,stopzeit.minute,stopzeit.sekunde);
	dlg.m_Stop = buffer;

	if (dlg.DoModal() == IDOK)
	{
		sscanf(dlg.m_Start,"%d:%d:%d",&startzeit.stunde,&startzeit.minute,&startzeit.sekunde);
		sscanf(dlg.m_Stop,"%d:%d:%d",&stopzeit.stunde,&stopzeit.minute,&stopzeit.sekunde);
	}
}

void CAVIMonitorDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
	//TRACE("OnTimer\n");
	if (timerRuns)
	{
		CTime t = CTime::GetCurrentTime();
		if (!timer &&
			(t.GetHour()   == startzeit.stunde) &&
			(t.GetMinute() == startzeit.minute) &&
			(t.GetSecond() == startzeit.sekunde))
		{
			timer = TRUE;
			OnVideoCapturing();
		}

		if ((t.GetHour()   == stopzeit.stunde) &&
			(t.GetMinute() == stopzeit.minute) &&
			(t.GetSecond() == stopzeit.sekunde))
		{
			timer = FALSE;
		}

	}
	CDialog::OnTimer(nIDEvent);
}

void CAVIMonitorDlg::OnCapturingTimergesteuert() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	timerRuns = !timerRuns;
    ::CheckMenuItem(main_menu,ID_CAPTURING_TIMERGESTEUERT,MF_BYCOMMAND+((timerRuns == TRUE)?MF_CHECKED:MF_UNCHECKED));

	if (timerRuns)
	{
		char buffer[100];
		sprintf(buffer,"Timeraufnahme um %02d:%02d:%02d",startzeit.stunde,startzeit.minute,startzeit.sekunde);
	    SetWindowText(buffer);     
	}
	else
	{
	    SetWindowText("Timer gestoppt");     
	}
}


void CAVIMonitorDlg::OnHilfeInfo() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
}

void CAVIMonitorDlg::OnHilfeIndex() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	::WinHelp(m_hWnd,"avimonitor.hlp",HELP_CONTENTS,0);
}

DWORD LadeLONG(FILE *f)
{
	DWORD tmp;
	fread(&tmp,4,1,f);
	return tmp;
}

double LadeDOUBLE(FILE *f)
{
	double tmp;
	fread(&tmp,8,1,f);
	return tmp;
}

char *LadeSTRING(FILE *f)
{
	static char tmp[1000];
	DWORD len;

	len = LadeLONG(f);
	if (len == 0) 
	{
		// Fehler
		tmp[0] = 0;
		return tmp;
	}
	fread(tmp,1,len,f);
	return tmp;
}

void LadeARRAY(FILE *f, void *w, DWORD max)
{
	DWORD len;

	len = LadeLONG(f);
	if (len == 0) 
	{
		// Fehler
		return;
	}
	if (len > max) len = max;	// Fehler
								// -> wenn die Lnge nicht bereinstimmt, wurde wahrscheinlich
								//    die Konfig eines anderen Treibers geladen
								// -> Konfig wird dann sowieso verworfen, kein Abbruch notwendig
	
	fread(w,1,len,f);
	return;
}

void CAVIMonitorDlg::DateiLaden(LPCTSTR pfad, BOOL msg) 
{
		FILE				*f;
		DWORD				version;
		DWORD				dwSize;
		LPWAVEFORMATEX      wfxSelection = NULL; 
		LPBITMAPINFO		bi = NULL;
		int					vl;
		
		
		// Audioformat
		acmMetrics(NULL,ACM_METRIC_MAX_SIZE_FORMAT,&dwSize);
		dwSize = max (dwSize, capGetAudioFormatSize (m_hCaptureWnd));
		wfxSelection = (LPWAVEFORMATEX) malloc(dwSize);
		if (!wfxSelection)
			return;	// Fehler

		//Videoformat
		vl = capGetVideoFormat(m_hCaptureWnd,NULL,0);
		if (vl > 0)
		{
			bi = (LPBITMAPINFO)malloc(vl);
			if (!bi)
			{
					TRACE("Fehler: bi = NULL\n");
					free(wfxSelection) ;
					return;
			}
		}
		else
		{
			TRACE("Fehler in capGetVideoFormat: Lnge = 0\n");
			free(wfxSelection) ;
			return;
		}

		f = fopen(pfad,"rb");	// Daten binr laden
		if (f)
		{
			// Daten speichern
			char szDeviceName[80];
			char szDeviceVersion[80];
			CString DevName;
			
			capGetDriverDescription (m_DriverNum, szDeviceName, sizeof (szDeviceName), szDeviceVersion, sizeof (szDeviceVersion));

			version = LadeLONG(f);
			if (version >= 1)
			{			
				// Daten speichern
				DevName = LadeSTRING(f);
				m_max	= LadeLONG(f);
				m_l1	= LadeLONG(f);
				m_l2	= LadeLONG(f);
				m_l3	= LadeLONG(f);
				m_l4	= LadeLONG(f);
				m_Rate	= LadeDOUBLE(f);
				m_p1	= LadeSTRING(f);
				m_p2	= LadeSTRING(f);
				m_p3	= LadeSTRING(f);
				m_p4	= LadeSTRING(f);
				LadeARRAY(f,wfxSelection,dwSize);	
				komprimierung = LadeLONG(f);
				LadeARRAY(f,&compressopts, sizeof(compressopts));	
				compressopts.lpFormat = 0;
				compressopts.lpParms  = 0;
				LadeARRAY(f,&startzeit,sizeof(startzeit));	
				LadeARRAY(f,&stopzeit,sizeof(startzeit));	
				timerRuns = LadeLONG(f);
				OutModus  = LadeLONG(f);
				m_Dateiname = LadeSTRING(f);	
				LadeARRAY(f,bi,vl);
				if (strcmp(szDeviceName,DevName))
				{
					// Die Parameter gelten fr eine andere Capture-Hardware
					// -> Kompression ausschalten
					// -> Format wird verworfen

					komprimierung = FALSE;

					CString t1,t2,t3,t4,tx,t5;

					t1 = "Die Parameter sind gltig fr:\n";
					t2 = "\n\nDie aktuell eingestellte Hardware:\n";
					t3 = szDeviceName;
					t4 = "\n\nkann diese Parameter eventuell nicht verarbeiten!\n\n";
					t5 = "Deshalb werden folgende Einstellungen verworfen:\n   - Format\n   - Kompression";
					tx += t1+DevName+t2+t3+t4+t5;
					MessageBox(tx,"Hinweis",MB_OK|MB_ICONEXCLAMATION);
				}
				else
				{
					capSetVideoFormat(m_hCaptureWnd,bi,vl);
				}
				
				//-------------  V E R S I O N    2  ------------------
				if (version >= 2)
				{
					overlayStatisch	= LadeLONG(f);
				}
				//-------------  V E R S I O N    3  ------------------
				if (version >= 3)
				{
					DC10PlusTVOut	= LadeLONG(f);
				}

				//-------------  L A D E N   E N D E  -----------------
				CheckWindowDim();
			}
			
			// Schreibe den Dateinamen als "Default" Konfiguration in WIN.INI
			WriteProfileString("AVIMonitor","ConfigFile",pfad);

			// Dialog aktualisieren
			UpdateData(FALSE);

			// Men markieren: Timer
			::CheckMenuItem(main_menu,ID_CAPTURING_TIMERGESTEUERT,MF_BYCOMMAND+((timerRuns == TRUE)?MF_CHECKED:MF_UNCHECKED));
			
			// Men: Spezialbefehl fr DC10
			::CheckMenuItem(main_menu,IDM_SPEZIAL_DC10,MF_BYCOMMAND+(DC10PlusTVOut)?MF_CHECKED:0);
			
			// Falls Overlay nicht mglich ist -> Einstellung berschreiben (nur Preview)
			if (!CaptureCaps.fHasOverlay) OutModus = 1;
			// Overlay/Preview

			if (!OutModus)
				OnOverlay();
			else
				OnPreview();

			// Audio
			capSetAudioFormat(m_hCaptureWnd, wfxSelection, (WORD)dwSize) ;

			fclose(f);
		}
		else 
		{
			if (msg) MessageBox("Datei konnte nicht geffnet werden","Fehler",MB_OK|MB_ICONEXCLAMATION);
		}
		
		if (wfxSelection) free(wfxSelection) ;
		if (bi) free(bi) ;
}

void CAVIMonitorDlg::OnDateiLaden() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Konfigurationen (*.avm)|*.avm|Alle Dateien|*.*||", this);

	if (IDOK == dlg.DoModal())
	{
		// OK wurde gewhlt -> Konfiguration speichern
		CString pfad = dlg.GetPathName();

		TRACE("Dateiname %s\n",(LPCTSTR)pfad);
		DateiLaden(pfad,TRUE);
	}
}

BOOL SpeichereLONG(FILE *f, DWORD w) 
{
	if (fwrite(&w,4,1,f) != 1) return FALSE;
	return TRUE;
}

BOOL SpeichereDOUBLE(FILE *f, double w) 
{
	if (fwrite(&w,8,1,f) != 1) return FALSE;
	return TRUE;
}

BOOL SpeichereSTRING(FILE *f, LPCTSTR w) 
{
	DWORD len;

	len = strlen(w)+1;

	// Schreibe Stringlnge
	if (fwrite(&len,4,1,f) != 1) return FALSE;
	// Schreibe String
	if (fwrite(w,1,len,f) != len) return FALSE;
	return TRUE;
}

BOOL SpeichereARRAY(FILE *f, void *w, DWORD len) 
{
	// Schreibe Lnge
	if (fwrite(&len,4,1,f) != 1) return FALSE;
	// Schreibe Array
	if (fwrite(w,1,len,f) != len) return FALSE;
	return TRUE;
}

void CAVIMonitorDlg::OnDateiSpeichernunter() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	DWORD				dwSize;
	LPWAVEFORMATEX      wfxSelection; 
	LPBITMAPINFO		bi;
	int					vl;


	// Audioformat speichern
	acmMetrics(NULL,ACM_METRIC_MAX_SIZE_FORMAT,&dwSize);
	dwSize = max (dwSize, capGetAudioFormatSize (m_hCaptureWnd));
	if (wfxSelection = (LPWAVEFORMATEX) malloc(dwSize)) 
	{
		capGetAudioFormat(m_hCaptureWnd, wfxSelection, (WORD)dwSize) ;
	}

	//Videoformat
	vl = capGetVideoFormat(m_hCaptureWnd,NULL,0);
	if (vl > 0)
	{
		bi = (LPBITMAPINFO)malloc(vl);
	    if (!bi)
		{
				TRACE("Fehler: bi = NULL\n");
				return;
		}
	}
	else
	{
		TRACE("Fehler in capGetVideoFormat: Lnge = 0\n");
		return;
	}
	capGetVideoFormat(m_hCaptureWnd,bi,vl);
	

	CFileDialog dlg(FALSE, "AVM", NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Konfigurationen (*.avm)|*.avm|Alle Dateien|*.*||", this);

	if (IDOK == dlg.DoModal())
	{
		// OK wurde gewhlt -> Konfiguration speichern
		CString pfad = dlg.GetPathName();

		TRACE("Dateiname %s\n",(LPCTSTR)pfad);
	    UpdateData();

		FILE *f = fopen(pfad,"wb");	// Daten binr speichern
		BOOL alles_ok = FALSE;

		if (f)
		{
			while(TRUE)
			{
				if (!SpeichereLONG(f,DATEI_VERSION)) break;	// Version, wird beim Laden gepft

				// Daten speichern
				char szDeviceName[80];
				char szDeviceVersion[80];

				capGetDriverDescription (m_DriverNum, szDeviceName, sizeof (szDeviceName), szDeviceVersion, sizeof (szDeviceVersion));
				if (!SpeichereSTRING(f,szDeviceName)) break;	
				if (!SpeichereLONG(f,m_max)) break;	
				if (!SpeichereLONG(f,m_l1)) break;	 
				if (!SpeichereLONG(f,m_l2)) break;	
				if (!SpeichereLONG(f,m_l3)) break;	
				if (!SpeichereLONG(f,m_l4)) break;	
				if (!SpeichereDOUBLE(f,m_Rate)) break;	
				if (!SpeichereSTRING(f,m_p1)) break;	
				if (!SpeichereSTRING(f,m_p2)) break;	
				if (!SpeichereSTRING(f,m_p3)) break;	
				if (!SpeichereSTRING(f,m_p4)) break;	
				if (!SpeichereARRAY(f,wfxSelection,dwSize)) break;	
				if (!SpeichereLONG(f,komprimierung)) break;	
				if (!SpeichereARRAY(f,&compressopts,sizeof(compressopts))) break;	
				if (!SpeichereARRAY(f,&startzeit,sizeof(startzeit))) break;	
				if (!SpeichereARRAY(f,&stopzeit,sizeof(stopzeit))) break;	
				if (!SpeichereLONG(f,timerRuns)) break;	
				if (!SpeichereLONG(f,OutModus)) break;	
				if (!SpeichereSTRING(f,m_Dateiname)) break;	
				if (!SpeichereARRAY(f,bi,vl)) break;	
				if (!SpeichereLONG(f,overlayStatisch)) break;	
				if (!SpeichereLONG(f,DC10PlusTVOut)) break;	


				// Schreibe den Dateinamen als "Default" Konfiguration in WIN.INI
				WriteProfileString("AVIMonitor","ConfigFile",pfad);
				alles_ok = TRUE;
				break;
			}
			if (!alles_ok)
			{
				MessageBox("Fehler beim Schreiben der Daten","Fehler",MB_OK|MB_ICONEXCLAMATION);
			}
			fclose(f);
		}
		else
		{
			MessageBox("Datei konnte nicht erzeugt werden","Fehler",MB_OK|MB_ICONEXCLAMATION);
		}

	}
	if (wfxSelection) free(wfxSelection) ;
	if (bi) free(bi);
}

void CAVIMonitorDlg::OnButton1() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	OnVideoCapturing();
}

void CAVIMonitorDlg::OnAufnahmeComputerrunterfahrennachaufnahme() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	herunterfahren = !herunterfahren;
    ::CheckMenuItem(main_menu,ID_AUFNAHME_COMPUTERRUNTERFAHRENNACHAUFNAHME,MF_BYCOMMAND+((herunterfahren == TRUE)?MF_CHECKED:MF_UNCHECKED));
}

void CAVIMonitorDlg::OnOverlayStatic() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	overlayStatisch = !overlayStatisch;
	CheckWindowDim();
}

void CAVIMonitorDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen

	// Bei manchen Karten (z.B. DC10+) funktioniert das Verschieben nicht
	// -> Abhilfe: zuerst umschalten in Preview-Modus
	if (!OutModus)
	{
		capPreview(m_hCaptureWnd,1);
	}
	if (!::SetWindowPos(m_hCaptureWnd, NULL, CAP_WIN_POS_X, CAP_WIN_POS_Y, 0, 0, SWP_NOZORDER | SWP_NOSIZE))
	{
		TRACE("Fehler in SetWindowPos()\n");
	}
	if (!OutModus)
	{
		capPreview(m_hCaptureWnd,0);
		capOverlay(m_hCaptureWnd,1);
	}
}


void CAVIMonitorDlg::SetFilename() 
{
	strcpy(filename,m_Dateiname);
	file_start_nummer = 0;  // Default, falls keine Nummer angegeben wurde
	
	// Suche Filenummer (falls vorhanden)
	for(int t=0;t<(int)strlen(filename);t++)
	{
		if (filename[t] == ',')
		{
			filename[t] = 0;		// Endekennung fr Dateiname
			file_start_nummer = atoi(&filename[t+1]);
		}
	}

	MaxFileUseNum[0] = m_l1;
	Festplatte[0]    = m_p1;
	MaxFileUseNum[1] = m_l2;
	Festplatte[1]    = m_p2;
	MaxFileUseNum[2] = m_l3;
	Festplatte[2]    = m_p3;
	MaxFileUseNum[3] = m_l4;
	Festplatte[3]    = m_p4;
}

void CAVIMonitorDlg::CalcInfoLen() 
{
	DelInfoLen();

	vlen = capGetVideoFormat(m_hCaptureWnd,NULL,0);
	if (vlen > 0)
	{
		bi_info = (LPBITMAPINFO)malloc(vlen);
	    if (!bi_info)
		{
				TRACE("Fehler: bi_info = NULL\n");
				return;
		}
	}
	else
	{
		TRACE("Fehler in capGetVideoFormat: Lnge = 0\n");
		return;
	}

	alen = capGetAudioFormatSize(m_hCaptureWnd);
	if (alen > 0)
	{
		ba_info = (LPWAVEFORMATEX)malloc(alen);
	    if (!ba_info)
		{
				TRACE("Fehler: ba_info = NULL\n");
				return;
		}
	}
	else
	{
		TRACE("Fehler in capGetAudioFormat: Lnge = 0\n");
		return;
	}
}

void CAVIMonitorDlg::DelInfoLen() 
{
	if (bi_info)free(bi_info);
	bi_info = NULL;
	if (ba_info)free(ba_info);
	ba_info = NULL;
}

void CAVIMonitorDlg::SetCapParams() 
{
	capCaptureGetSetup(m_hCaptureWnd, &CaptureParms, sizeof(CAPTUREPARMS));
	CaptureParms.dwRequestMicroSecPerFrame	= (DWORD) ((1.0e6 / m_Rate)+0.5);
	CaptureParms.wNumVideoRequested			= 150;
	CaptureParms.wNumAudioRequested			= 50;
	CaptureParms.fLimitEnabled				= 0;
	CaptureParms.wTimeLimit					= 0;
	CaptureParms.fCaptureAudio				= 1;
	CaptureParms.dwIndexSize				= 324000; /* Maximalwert */
	CaptureParms.wStepCaptureAverageFrames	= 0;
	capCaptureSetSetup(m_hCaptureWnd, &CaptureParms, sizeof (CAPTUREPARMS)); 
	videoTimePerFrame = CaptureParms.dwRequestMicroSecPerFrame/1000;


	if (m_max >= 10)
	{
	  fileMax  = 1024*1024*m_max;
	}
	else
	{
	  fileMax  = 1024*1024*2000;
	}
	SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS);
	TRACE("Aufnahme....\n");

	capGetVideoFormat(captureDialog->m_hCaptureWnd,bi_info,vlen);
	capGetAudioFormat(captureDialog->m_hCaptureWnd,ba_info,alen);
}

void CAVIMonitorDlg::OnVideoCapturing() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	UpdateData();
	

	durchlauf  = FALSE;
	errorStop  = FALSE;
	m_Aufnahme = 1;			// Durch ESC wird normalerweise der Dialog geschlossen -> Verhinderung duch diese Variable

	dwSEvents = 0;


	if (m_Rate < 1.) 
	{
		m_Rate = 15.;	// Default
		UpdateData(FALSE);
	}

	if (OutModus == 1)
	{
		capPreviewRate(m_hCaptureWnd,(int)m_Rate);
	}

	SetFilename();
	SetCapParams();
	
	capCaptureSequenceNoFile (m_hCaptureWnd); 

	
	

    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	// !!!!!   A C H T U N G    W I C H T I G   !!!!!!
    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	// Das Event mit nType = 0x81 mu (!) das letzte
	// Event sein, weil die Variablen dwSEvents und
	// dwREvents neu gesetzt werden. ber diese Variablen
	// erfolgt zustzlich zu den Events die Synchronisation
	// (Events werden zum Teil "verschluckt", sch... Windows)
	
	
	// Schreibe Kennung: "AVI-Datei schlieen"
	// (Geht immer, da der Platz dafr reserviert wird)
	TRACE("Sende Nachricht an Thread: AVI-Datei schlieen\n");
	CheckPuffer(0);
	AVIDATEN *ptr = (AVIDATEN *)&AVIRawData[nPos2Write];
	ptr->nLength = 0;
	ptr->nTyp    = 0x81;
	ptr->Flags   = 0;
	ptr->nTime   = 0;
	nPos2Write += (sizeof(AVIDATEN)+8)& ~3;
	MySetEvent(hCapEvent);
	
	SetPriorityClass(GetCurrentProcess(),NORMAL_PRIORITY_CLASS);
	MessageBeep(MB_OK);

	m_Aufnahme = 0;

	if (herunterfahren)
	{
		PostMessage(WM_CLOSE);
		ExitWindowsEx(EWX_SHUTDOWN+EWX_POWEROFF,0);
	}
}

void CAVIMonitorDlg::OnSpezialDc10() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	DC10PlusTVOut=!DC10PlusTVOut;
    ::CheckMenuItem(main_menu,IDM_SPEZIAL_DC10,MF_BYCOMMAND+(DC10PlusTVOut)?MF_CHECKED:0);
}
