/* AVIThread.cpp : Implementierungsdatei
 * Copyright (C) 2000 Jrgen Eder
 *
 * $Header: /daten/sourcen/cvs/avimonitor/avithread.cpp,v 1.1 2000/05/20 14:18:43 je Exp $
 * $Revision: 1.1 $
 * $Date: 2000/05/20 14:18:43 $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AVIMonitor.h"
#include "AVIMonitorDlg.h"
#include "DlgProxy.h"
#include "timerdialog.h"
#include "AVICallback.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

PAVIFILE			pfile=0;
PAVISTREAM			psVideoCompressed=0;
PAVISTREAM			psVideo=0;
PAVISTREAM			psAudio=0;
DWORD				videoStreamCounter=0;		// Zhler fr eine einzelne Datei
DWORD				fileByteCounter=0;			// Bereits geschriebene Datenbytes (zur Anzeige)

void CloseCapturingFile() 
{
	if (psAudio)			AVIStreamRelease(psAudio);
	if (psVideo)			AVIStreamRelease(psVideo);
	if (psVideoCompressed)	AVIStreamRelease(psVideoCompressed);
	if (pfile)				AVIFileRelease(pfile);

	pfile   = 0;
	psAudio = 0;
	psVideo = 0;
	psVideoCompressed = 0;
}

BOOL OpenCapturingFile(LPCTSTR hard_disk, LPCTSTR name, int num) 
{
	char buffer[512];
	HRESULT hr;
	AVISTREAMINFO videoStrhdr,audioStrhdr;


	CloseCapturingFile();

	memset(&videoStrhdr, 0, sizeof(videoStrhdr));
	videoStrhdr.fccType                = streamtypeVIDEO;// stream type
	if (DC10PlusTVOut)
	{
		videoStrhdr.fccHandler             = mmioFOURCC('M','J','P','G');;
	}
	else
	{
		videoStrhdr.fccHandler             = 0;
	}
	videoStrhdr.dwScale                = CaptureParms.dwRequestMicroSecPerFrame;
	videoStrhdr.dwRate                 = 1000000;
	videoStrhdr.dwSuggestedBufferSize  = 0;
	videoStrhdr.dwQuality			   = -1;
	SetRect(&videoStrhdr.rcFrame, 0, 0,bi_info->bmiHeader.biWidth,bi_info->bmiHeader.biHeight);

	memset(&audioStrhdr, 0, sizeof(audioStrhdr));
	audioStrhdr.fccType                = streamtypeAUDIO;// stream type
	audioStrhdr.fccHandler             = 0;
	audioStrhdr.dwScale                = ba_info->nBlockAlign;//ba_info->nAvgBytesPerSec;
	audioStrhdr.dwRate                 = ba_info->nAvgBytesPerSec;//ba_info->nSamplesPerSec;
	audioStrhdr.dwSampleSize           = ba_info->nBlockAlign;
	audioStrhdr.dwQuality			   = -1;

	sprintf(buffer,"%s:\\%s%03d.avi",hard_disk,name,num);
	sprintf(aktuelle_file,"%s%03d.avi",name,num);
	hr = AVIFileOpen(&pfile,buffer,OF_WRITE|OF_CREATE,NULL);	// use handler determined
															// from file extension....
	if (hr != AVIERR_OK)
		return FALSE;


	hr = AVIFileCreateStream(pfile,&psVideo,&videoStrhdr);	    
	if (hr != AVIERR_OK) 
	{
		TRACE("Fehler in AVIFileCreateStream (Video)\n");
		return FALSE;
	}
	
	if (komprimierung)
	{
		hr = AVIMakeCompressedStream(&psVideoCompressed, psVideo, &compressopts, NULL);
		if (hr != AVIERR_OK) 
		{
			TRACE("Fehler in AVIMakeCompressedStream()\n");
			return FALSE;
		}
		
		
		hr = AVIStreamSetFormat(psVideoCompressed, 0, &bi_info->bmiHeader, bi_info->bmiHeader.biSize+bi_info->bmiHeader.biClrUsed * sizeof(RGBQUAD));
		if (hr != AVIERR_OK) 
		{
			TRACE("Fehler in AviStreamSetFormat()\n");
			return FALSE;
		}
	}
	else
	{
		hr = AVIStreamSetFormat(psVideo, 0, &bi_info->bmiHeader, bi_info->bmiHeader.biSize+bi_info->bmiHeader.biClrUsed * sizeof(RGBQUAD));
		if (hr != AVIERR_OK) 
		{
			TRACE("Fehler in AviStreamSetFormat()\n");
			return FALSE;
		}
	}
	
	
	hr = AVIFileCreateStream(pfile,&psAudio,&audioStrhdr);	    
	if (hr != AVIERR_OK) 
	{
		TRACE("Fehler in AVIFileCreateStream (Audio)\n");
		return FALSE;
	}
	
	hr = AVIStreamSetFormat(psAudio, 0, ba_info, alen);
	if (hr != AVIERR_OK) 
	{
		TRACE("Fehler in AviStreamSetFormat (Audio)\n");
		return FALSE;
	}
	
	return TRUE;
}

DWORD WINAPI Speichern(LPVOID lpThreadParam)
{
	HRESULT				hr;
	long				dwWritten;
	AVIDATEN			*ptr;
	DWORD				audioStreamCounter=0;		// Zhler fr eine einzelne Datei
	int					fileUseNum=0;					// Dateinummer
	int					festplatte;
	int					fileNum;
	long				videoTime;
	BOOL				start;
	PAVISTREAM			ps=0;

	dwREvents = 0;

	while(!bThreadStoppen)
	{
		dwREvents++;
		if (dwREvents > dwSEvents)
		{
			WaitForSingleObject(hCapEvent, INFINITE);
		}
		ResetEvent(hCapEvent);
		
		
		//TRACE("Testnummer = %d %d\n",dwREvents,dwSEvents);

		if (bThreadStoppen) break;	// Event durch Programmende

		
	    ptr = (AVIDATEN *)&AVIRawData[nPos2Read];
        //TRACE("SChreibe Daten im Thread %d %d %d\n",ptr->Flags, ptr->nLength, ptr->nTyp);
		
		if (!(ptr->nTyp & 0x80))  // Video- oder Audiodaten
		{
			if (!ps)			// Datei noch nicht offen -> jetzt ffnen
			{
				if (file_start_nummer >= 0)
				{
					fileUseNum = file_start_nummer;
					file_start_nummer = -1;
					fileNum = 0;
					start = TRUE;

					// Suche Festplattenbezeichnung
					for(festplatte=0;festplatte<4;festplatte++)
					{
						if (!Festplatte[festplatte].IsEmpty()) break;
					}
				}

				TRACE("fileNum %d\n",fileNum);
				if ((festplatte < 4) && (fileNum >= MaxFileUseNum[festplatte]))
				{
					// Suche nchste Festplattenbezeichnung
					for(festplatte++;festplatte<4;festplatte++)
					{
						if (!Festplatte[festplatte].IsEmpty()) 
						{
							fileNum=0;
							break;
						}
					}
				}
				TRACE("festplatte %d %d\n",festplatte,fileUseNum);
				if (festplatte < 4)
				{
					OpenCapturingFile(Festplatte[festplatte], filename, fileUseNum);
					fileNum++;
					fileByteCounter = 0;
					videoStreamCounter=0;
					audioStreamCounter=0;
					ps = (komprimierung)?psVideoCompressed:psVideo;
					if (!ps)
					{
						TRACE("Fehler: AVI-Datei nicht geffnet\n");
						errorStop = TRUE;
					}
				}
				else
				{
						errorStop = TRUE;
				}
			}
		}

		if (ps && (ptr->nTyp == 0))  // Schreibe Videodaten
		{
			long drops=0;
			if (start)	// Aufnahme wurde gestartet -> merke mir ersten Zeitstempel
			{
				videoTime = ptr->nTime;
				start = FALSE;
				videoDropOuts = 0;
			}
			else				// Aufnahme luft bereits, untersuche jetzt, ob Frames ausgelassen wurden
			{					// (= drop outs)
				if (videoTimePerFrame > 0)  // Sicherheitsabfrage
				{
					drops = ((ptr->nTime-videoTime)/videoTimePerFrame)-1;
					//DropOut: 12 4294940 40 107266808 <- diese Werte traten bei einem berlauf auf
					//TRACE("Test1: %ld %ld %ld \n",lpVHdr->dwTimeCaptured,videoTime,videoTimePerFrame);
					if (drops > 1000) // Fehler: berlauf (im Treiber)
					{
						drops = 0;
					}
					if (drops < 0)			// drfte eigentlich nicht vorkommen ?!
					{
						drops = 0;
					}
					
					if (drops > 1)
					{
						videoDropOuts+=drops;
						//TRACE("DropOut: %ld %ld %ld %ld\n",ptr->nTime,videoTime,videoTimePerFrame,drops);
					}
					
					videoTime = ptr->nTime;
				}
			}
			
			while(drops >= 0)
			{
				hr = AVIStreamWrite(ps,// stream pointer
					videoStreamCounter++,			// time of this frame
					1,								// number to write
					(LPBYTE) &AVIRawData[nPos2Read+sizeof(AVIDATEN)],
					ptr->nLength,					// size of this frame
					ptr->Flags,			 // flags....
					NULL,
					&dwWritten);
				if (hr != AVIERR_OK)
				{
					errorStop = TRUE;
					TRACE("Fehler in StreamWrite (Video)%ld\n",hr);
				}
				fileByteCounter+=dwWritten;
				drops--;
			}
		}
		
		if (psAudio && (ptr->nTyp == 1))  // Schreibe Audiodaten
		{
			hr = AVIStreamWrite(psAudio,// stream pointer
				audioStreamCounter,					// time of this frame
				ptr->nLength/ptr->nBlockAlign,		// number to write
				(LPBYTE) &AVIRawData[nPos2Read+sizeof(AVIDATEN)],
				ptr->nLength,						// size of this frame
				ptr->Flags,							// flags....
				NULL,
				&dwWritten);
			audioStreamCounter += ptr->nLength/ptr->nBlockAlign;
			//fileByteCounter+=ptr->nLength;
			//	TRACE("Audio: %ld\n",audioStreamCounter);
			fileByteCounter+=dwWritten;

		
			if (fileByteCounter >= fileMax)
			{
				fileUseNum++;
				CloseCapturingFile();
				ps = 0;
			}
		
		
		}
	
		
		if (ptr->nTyp == 0x81) // "AVI-Datei schlieen"
		{
			TRACE("Schliee AVI-Datei\n");
			CloseCapturingFile();
			ps = 0;
			dwREvents = 0;
			dwSEvents = 0;
		}

		if (ptr->nTyp == 0x80) // "Puffer Neustart"
		{
			TRACE("Setze nPos2Read auf 0\n");
			nPos2Read = 0;
			durchlauf = FALSE;
		}
		else
		{
//			TRACE("Neue nPos2Read: %d %d %d %ld->",ptr->nLength, ptr->nTyp, ptr->Flags,nPos2Read);
			nPos2Read += (sizeof(AVIDATEN)+ptr->nLength+8)& ~3;
//			TRACE("%ld = %ld\n",nPos2Read,dwWritten);
		}


	}

	TRACE("*******************************************\n");
	TRACE("Thread wird beendet\n");
	TRACE("*******************************************\n");
	return 0;
}

