/* DlgProxy.cpp : Implementierungsdatei
 * Copyright (C) 2000 Jrgen Eder
 *
 * $Header: /daten/sourcen/cvs/avimonitor/dlgproxy.cpp,v 1.2 2000/03/05 17:05:30 je Exp $
 * $Revision: 1.2 $
 * $Date: 2000/03/05 17:05:30 $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AVIMonitor.h"
#include "DlgProxy.h"
#include "AVIMonitorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAVIMonitorDlgAutoProxy

IMPLEMENT_DYNCREATE(CAVIMonitorDlgAutoProxy, CCmdTarget)

CAVIMonitorDlgAutoProxy::CAVIMonitorDlgAutoProxy()
{
	EnableAutomation();
	
	// Um die Ausfhrung der Anwendung fortzusetzen, solange ein Automatisierungsobjekt
	//	aktiv ist, ruft der Konstruktor AfxOleLockApp auf.
	AfxOleLockApp();

	// Greifen Sie ber den Hauptfensterzeiger der Anwendung auf das
	//  Dialogfeld zu. Setzen Sie den internen Zeiger des Proxy
	//  auf das Dialogfeld und den Gegenzeiger (Back Pointer) des Dialogfelds 
	//  auf diesen Proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CAVIMonitorDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CAVIMonitorDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CAVIMonitorDlgAutoProxy::~CAVIMonitorDlgAutoProxy()
{
	// Um die Anwendung zu beenden, sobald alle mit Automatisierung erstellten
	// Objekte freigegeben sind, ruft der Destruktor AfxOleUnlockApp auf.
	//  Dies zerstrt unter anderem das Hauptdialogfeld.
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CAVIMonitorDlgAutoProxy::OnFinalRelease()
{
	// Wird der letzte Verweis auf ein Automatisierungsobjekt freigegeben,
	// wird OnFinalRelease aufgerufen. Die Basisklasse lscht das Objekt
	// automatisch. Fgen Sie zustzlichen Bereinigungscode fr Ihr Objekt
	// hinzu, bevor Sie die Basisklasse aufrufen.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CAVIMonitorDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CAVIMonitorDlgAutoProxy)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CAVIMonitorDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CAVIMonitorDlgAutoProxy)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.

	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Hinweis: Wir stellen Untersttzung fr IID_IAVIMonitor zur Verfgung, um typsicheres Binden 
//  von VBA zu untersttzen. Diese IID muss mit der GUID bereinstimmen, die bei der 
//  Disp-Schnittstelle in der .ODL-Datei angegeben ist.

// {9F3DC382-C7A6-11D3-84A6-0080C6FF24F7}
static const IID IID_IAVIMonitor =
{ 0x9f3dc382, 0xc7a6, 0x11d3, { 0x84, 0xa6, 0x0, 0x80, 0xc6, 0xff, 0x24, 0xf7 } };

BEGIN_INTERFACE_MAP(CAVIMonitorDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CAVIMonitorDlgAutoProxy, IID_IAVIMonitor, Dispatch)
END_INTERFACE_MAP()

// Das Makro IMPLEMENT_OLECREATE2 ist in der Datei StdAfx.h dieses Projekts definiert
// {9F3DC380-C7A6-11D3-84A6-0080C6FF24F7}
IMPLEMENT_OLECREATE2(CAVIMonitorDlgAutoProxy, "AVIMonitor.Application", 0x9f3dc380, 0xc7a6, 0x11d3, 0x84, 0xa6, 0x0, 0x80, 0xc6, 0xff, 0x24, 0xf7)

/////////////////////////////////////////////////////////////////////////////
// CAVIMonitorDlgAutoProxy Nachrichten-Handler
