/* stdafx.h : Include-Datei fr Standard-System-Include-Dateien,
 *  oder projektspezifische Include-Dateien, die hufig benutzt, aber
 *      in unregelmigen Abstnden gendert werden.
 * Copyright (C) 2000 Jrgen Eder
 *
 * $Header: /daten/sourcen/cvs/avimonitor/stdafx.h,v 1.3 2000/05/20 14:18:47 je Exp $
 * $Revision: 1.3 $
 * $Date: 2000/05/20 14:18:47 $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#if !defined(AFX_STDAFX_H__9F3DC38C_C7A6_11D3_84A6_0080C6FF24F7__INCLUDED_)
#define AFX_STDAFX_H__9F3DC38C_C7A6_11D3_84A6_0080C6FF24F7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define VC_EXTRALEAN		// Selten verwendete Teile der Windows-Header nicht einbinden

#include <afxwin.h>         // MFC-Kern- und -Standardkomponenten
#include <afxext.h>         // MFC-Erweiterungen
#include <afxdisp.h>        // MFC Automatisierungsklassen
#include <afxdtctl.h>		// MFC-Untersttzung fr allgemeine Steuerelemente von Internet Explorer 4
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC-Untersttzung fr gngige Windows-Steuerelemente
#endif // _AFX_NO_AFXCMN_SUPPORT


#include <vfw.h>		// Video fr Windows

// Dieses Makro ist identisch mit IMPLEMENT_OLECREATE, auer dass es den Wert TRUE
//  fr den Parameter bMultiInstance des Konstruktors COleObjectFactory bergibt.
//  Wir wollen fr jedes Proxy-Objekt der Automatisierung, das von
//  Automatisierungs-Controllern angefordert wird, eine eigene Instanz dieser Anwendung starten.
#ifndef IMPLEMENT_OLECREATE2
#define IMPLEMENT_OLECREATE2(class_name, external_name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
	AFX_DATADEF COleObjectFactory class_name::factory(class_name::guid, \
		RUNTIME_CLASS(class_name), TRUE, _T(external_name)); \
	const AFX_DATADEF GUID class_name::guid = \
		{ l, w1, w2, { b1, b2, b3, b4, b5, b6, b7, b8 } };
#endif // IMPLEMENT_OLECREATE2

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.


#define DATEI_VERSION 3
//#define MAX_CAP_FILES 50

#define CAP_WIN_POS_X 120
#define CAP_WIN_POS_Y 20



// Einstellungen fr Timeraufnahmen
#define ANZ_BYTES 5000000

typedef unsigned char UBYTE;
typedef UBYTE *LPUBYTE;

typedef struct AVIDaten
{
	long			nLength;	// Anzahl der zu schreibenden Datenbytes
	long            Flags;
	short			nTyp;		// 0 = Video / 1 = Audio
	DWORD           nTime;
	long            nBlockAlign;
}AVIDATEN;


typedef struct
{
	int stunde;
	int minute;
	int sekunde;
}TIMERAUFNAHME;

extern BOOL					overlayStatisch;
extern BOOL					herunterfahren;
extern BOOL					komprimierung;
extern int					OutModus;					// 0=Overlay, 1=Preview

class CAVIMonitorDlg;
extern CAVIMonitorDlg	   *captureDialog;
extern DWORD				videoTimePerFrame;			// Zeit in ms pro Frame
extern DWORD				fileMax;		// maximale Dateigre (Standard 2 GByte)
extern BOOL					errorStop;					// TRUE : Aufnahme beenden (per Timer, oder durch Fehler)

extern BOOL					DC10PlusTVOut;


extern char					aktuelle_file[];
extern char					filename[];
extern int					file_start_nummer;
extern int					MaxFileUseNum[];
extern CString				Festplatte[];

extern AVICOMPRESSOPTIONS	compressopts;
extern CAPDRIVERCAPS		CaptureCaps;
extern CAPTUREPARMS			CaptureParms;
extern DWORD				vlen;					// Strukturgre: bi_info
extern DWORD				alen;					// Strukturgre: ba_info
extern LPBITMAPINFO			bi_info;
extern LPWAVEFORMATEX		ba_info;
extern BOOL					timer;			// TRUE = Aufnahme luft
extern BOOL					timerOk;		// SetTimer() hat funktioniert
extern UINT					timer1;
extern BOOL					timerRuns;		// Timergesteuerte Aufnahme
extern TIMERAUFNAHME		startzeit,stopzeit;

extern long					nMaxAVIRawData;
extern long					nPos2Write;			// Auf den Heap schreiben (Hauptthread)
extern long					nPos2Read;			// Aus dem Heap lesen um die Daten in eine AVI Datei zu schreiben (Thread)
extern LPUBYTE				AVIRawData[];		// Zeiger auf Heap (GMEM_FIXED-Memory)
extern BOOL					durchlauf;				// Wird bentigt zur Berechnung der Ringpufferposition

extern HANDLE				hThread;
extern BOOL					bThreadStoppen;
extern HANDLE				hCapEvent;

extern DWORD				dwSEvents;
extern DWORD				dwREvents;

extern DWORD				videoStreamCounter;		// Zhler fr eine einzelne Datei
extern DWORD				fileByteCounter;			// Bereits geschriebene Datenbytes (zur Anzeige)
extern DWORD				videoDropOuts;

// Die Standard-Funktionen der MFC sind scheinbar fehlerhaft, wenn eine Dialogbox-Anwendung
// ein Men hat!
// -> WINDOWS-API verwenden (funktioniert immer)
extern HMENU				main_menu;


DWORD WINAPI Speichern(LPVOID lpThreadParam);
BOOL MySetEvent(HANDLE event);



#endif // !defined(AFX_STDAFX_H__9F3DC38C_C7A6_11D3_84A6_0080C6FF24F7__INCLUDED_)
